
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Effective Java(3) 用私有构造器或者枚举类型强化Singleton属性 / iVAN</title>

    <meta name="description" content="Effective Java(3) 用私有构造器或者枚举类型强化Singleton属性 一.背景 所谓的Singleton是指仅仅被实例化一次的类,Singleton通常被用来代表那些本质上唯一的系统组件. 实现Singleton有以下三种方法: ①. 私有构造器,公有静态final域. ②. 私有构造器,公有静态工厂方法. ③. 单元素枚举类型(首选). 二.私有构造器,公有静态final域 public class Singleton1 { public static final Singleton1 INSTANCE = new Singleton1(); // 公有静态fi">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Effective Java(3) 用私有构造器或者枚举类型强化Singleton属性</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>一、背景</p>
<p>所谓的Singleton是指仅仅被实例化一次的类，Singleton通常被用来代表那些本质上唯一的系统组件。</p>
<p>实现Singleton有以下三种方法：</p>
<p>①. 私有构造器，公有静态final域。</p>
<p>②. 私有构造器，公有静态工厂方法。</p>
<p>③. 单元素枚举类型（首选）。</p>
<p>二、私有构造器，公有静态final域</p>
<pre>
public class Singleton1 {  

    public static final Singleton1 INSTANCE = new Singleton1(); // 公有静态final域  

    /*
     * 私有构造器
     */
    private Singleton1() {
    }  

}</pre>
<p>三、私有构造器，公有静态工厂方法</p>
<p>缺点1：享有特权的客户端可以借助AccessibleObject.setAccessible方法，通过反射机制，调用私有构造器，如果需要抵御这种攻击，可以修改构造器，让它在被要求创建第二个实例的时候抛出异常。</p>
<pre>
public class Singleton2 {
    private static final Singleton2 INSTANCE = new Singleton2(); // 私有静态final域  

    /*
     * 私有构造器
     */
    private Singleton2() {
    }  

    /*
     * 公有静态工厂方法
     */
    public static Singleton2 getInstance() {
        return INSTANCE;
    }  

}</pre>
<p>查看本栏目更多精彩内容：http://www.bianceng.cnhttp://www.bianceng.cn/Programming/Java/</p>
<p>缺点2：每次反序列化一个序列化的实例时，都会创建一个新的实例，为了防止这种情况，不仅要实现Serializable接口，还要提供一个readResolve方法。</p>
<pre>
public class Singleton2 implements Serializable {
    private static final long serialVersionUID = 1L;
    private static final Singleton2 INSTANCE = new Singleton2(); // 私有静态final域  

    /*
     * 私有构造器
     */
    private Singleton2() {
    }  

    /*
     * 公有静态工厂方法
     */
    public static Singleton2 getInstance() {
        return INSTANCE;
    }  

    /*
     * 反序列化确保只有一个实例
     */
    public Object readResolve() {
        return INSTANCE;
    }  

}</pre>
<p>四、单元素枚举类型</p>
<p>最佳方法：更简洁，无偿提供序列化机制，绝对防止多次实例化，即使是面对复杂的序列化或反射攻击的时候。</p>
<pre>
public enum Singleton3 {
    INSTANCE;  

    public void testSingleton() {
        System.out.println("testSingleton");
    }  

    public static void main(String[] args) {
        Singleton3.INSTANCE.testSingleton();
    }
}</pre>
<p>作者：csdn博客 zdp072</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索静态<br />
                    ，                instance<br />
                    ，                public<br />
                    ，                构造器<br />
                    ，                反射的实例化异常<br />
                    ，                公有域<br />
                    ，                公有<br />
                    ，                私有<br />
                    ，                私有属性<br />
                                    私有方法<br />
                                    私有构造函数、构造函数私有化、java私有构造函数、构造方法私有化、私有构造方法，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-03 05:52:44</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/public/" title="public">public</a>, <a href="https://www.iamivan.net/tag/%e9%9d%99%e6%80%81/" title="静态">静态</a>, <a href="https://www.iamivan.net/tag/%e6%9e%84%e9%80%a0%e5%99%a8/" title="构造器">构造器</a>, <a href="https://www.iamivan.net/tag/%e5%85%ac%e6%9c%89/" title="公有">公有</a>, <a href="https://www.iamivan.net/tag/%e7%a7%81%e6%9c%89/" title="私有">私有</a>, <a href="https://www.iamivan.net/tag/%e7%a7%81%e6%9c%89%e5%b1%9e%e6%80%a7/" title="私有属性">私有属性</a>, <a href="https://www.iamivan.net/tag/%e7%a7%81%e6%9c%89%e6%96%b9%e6%b3%95/" title="私有方法">私有方法</a>, <a href="https://www.iamivan.net/tag/instance/" title="instance">instance</a>, <a href="https://www.iamivan.net/tag/%e5%85%ac%e6%9c%89%e5%9f%9f/" title="公有域">公有域</a>, <a href="https://www.iamivan.net/tag/%e5%8f%8d%e5%b0%84%e7%9a%84%e5%ae%9e%e4%be%8b%e5%8c%96%e5%bc%82%e5%b8%b8/" title="反射的实例化异常">反射的实例化异常</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Effective Java(3) 用私有构造器或者枚举类型强化Singleton属性的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/VMrx7vz.html" rel="bookmark">Effective Java &lpar;4&rpar; 通过私有构造器强化不可实例化的能力</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.背景 对于有些工具类如java.lang.Math.java.util.Arrays等,它们只包含静态方法和静态域字段,对于这样的类实例化没有什么任何意义.但在实际使用中,如果不加任何特殊处理,这样的类还是可以像其他类一样可以被实例化. 二.处理办法 将构造函数设置为private,这样外部类无法实例化该类,同时在这个私有的构造函数中直接抛出异常,从而避免在类的内部实例化. public class UtilityClass { // 私有的构造器,内部实例化会抛出异常 private Ut			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba6XqmM.html" rel="bookmark">java小白求助：如何使用枚举类型？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 看&lt;java编程思想&gt;中关于枚举的用法,我把枚举类型和一个类放在一块,结果总是在枚举定义的地方报错:thepublictypeSpicinessmustbedefinedinitsownfile.请问这是怎么回事呢?小白拜谢大家了 解决方案 解决方案二:那就别放在一块.一个文件只能有一个对外的publicclass.解决方案三:引用1楼u011461314的回复: 那就别放在一块.一个文件只能有一个对外的publicclass. 意思是说,我需要建一个包,然后新建枚举,然后在Burr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mrqv9mb.html" rel="bookmark">《Effective Objective-C 2&period;0》3、枚举类型表示状态、选项</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第五条:使用枚举类型表示状态和选项,可以使代码更加清晰,可读性更好. 枚举类型使用关键字enum定义,通常与typedef相结合,定义一组状态或选项: typedef enum CustomState { CustomStateNone, CustomStateDefault, CustomStateAnother, } CustomState; 此后,就可以像内建类型一样使用CustomState定义变量: CustomState state = CustomStateDefault; 定义枚			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRDkAqz.html" rel="bookmark">和我一起学Effective Java之创建和销毁对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 主要学习创建和销毁对象: 1.何时以及如何创建对象 2.何时以及如何避免创建对象 3.如何确保它们能够适时地销毁 4.如何管理对象销毁之前必须进行的清理动作 正文 一.用静态工厂方法代替构造器 获取类的实例的常用方法有: 1.公有的构造器 2.公有的静态工厂方法 下面通过Boolean类(基本类型boolean的包装类)的简单示例来学习: //公有的构造器 public Boolean(String s) { this(parseBoolean(s)); } //公有的静态工厂方法 pub			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN25X4M.html" rel="bookmark">《Effective Java》&mdash;&mdash; 创建与销毁对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本篇主要总结的是&lt;Effecticve Java&gt;中关于创建和销毁对象的内容. 比如: 何时以及如何创建对象 何时以及如何避免创建对象 如何确保及时销毁 如何管理对象销毁前的清理动作 考虑用静态工厂方法代替构造器 使用静态工厂的优势: 有名称 不必每次调用的时候都创建一个新的对象 返回原返回类型的任何子类型对象 在创建参数化类型实例时,代码更加简洁. 使用静态工厂的缺点: 类如果不包含公有的或者受保护的构造器,就不能被子类化 与其他的静态方法实际上没有任何区别 举个例子: public cla			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW2JKEb.html" rel="bookmark">Effective Java 笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				创建和销毁对象 NO.1 考虑用静态工厂方法代替构造函数 静态工厂方法好处: 1.构造函数有命名的限制,而静态方法有自己的名字,更加易于理解. 2.静态工厂方法在每次调用的时候不要求创建一个新的对象.这种做法对于一个要频繁创建相同对象的程序来说,可以极大的提高性能.它使得一个类可以保证是一个singleton:他使非可变类可以保证&quot;不会有两个相等的实例存在&quot;. 3.静态工厂方法在选择返回类型时有更大的灵活性.使用静态工厂方法,可以通过调用方法时使用不同的参数创建不同类的实例,还可以创建			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5olJnb.html" rel="bookmark">深度分析 Java 的枚举类型：枚举的线程安全性及序列化问题（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				写在前面: Java SE5 提供了一种新的类型 Java的枚举类型,关键字 enum 可以将一组具名的值的有限集合创建为一种新的类型,而这些具名的值可以作为常规的程序组件使用,这是一种非常有用的功能.本文将深入分析枚举的源码,看一看枚举是怎么实现的,是如何保证线程安全的,以及为什么用枚举实现的单例是最佳方式. 枚举是如何保证线程安全的 要想看源码,首先得有一个类吧,那么枚举类型到底是什么类呢?是enum吗?答案很明显不是,enum就和class一样,只是一个关键字,他并不是一个类,那么枚举是由			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEYOgob.html" rel="bookmark">Java的枚举类型使用方法详解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.背景在java语言中还没有引入枚举类型之前,表示枚举类型的常用模式是声明一组具有int常量.之前我们通常利用public final static 方法定义的代码如下,分别用1 表示春天,2表示夏天,3表示秋天,4表示冬天. public class Season { public static final int SPRING = 1; public static final int SUMMER = 2; public static final int AUTUMN = 3; publi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0borO3z.html" rel="bookmark">Effective Java &lpar;2&rpar; 遇到多个构造器参数时要考虑用构建器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.背景 对于有多个可选参数的类,我们一般通过什么办法传递参数呢?这里提供了三种办法: ①. 重叠构造器模式 ②. JavaBeans模式 ③. Builder构建器模式 下面我们来分析一下以上三种方法的优势及弊端. 二.重叠构造器模式 重叠构造器模式中第一个构造器中只有必要参数,第二个构造器有一个可选参数,第三个构造器中有两个可选参数,依次类推,最后一个构造器中包含所有可选参数.这种方案可行,但是有较大缺陷. 缺点:当有很多可选参数的时候,客户端代码很难编写,并难以阅读,如果客户端不小心颠倒了			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpdvr2b.html" rel="bookmark" class="title">android-如何从其它的方法中删除对话框？</a>
					<div>
						问题描述 如何从其它的方法中删除对话框? 我创建一个对话框,按照下面的代码,提供一个标题和消息,这个对话框可以在任何地方被调用. public void alertbox(String title,  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYmXeM.html" rel="bookmark" class="title">如何用php生成WAP页面</a>
					<div>
						页面 WAP(无线通讯协议)是在数字移动电话.个人手持设备(PDA等)及计算机之间进行通讯的开放性全球标准.由于静态的WAP页面在很多方面不能满足用户个性化的服务请求,因此通过WAP服务器端语言产生动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9Dlvb.html" rel="bookmark" class="title">桌面中心&lpar;一&rpar;创建数据库</a>
					<div>
						这是小弟第一次写文章.不知道能不能发布呀..我把程序写出来是想要大家参考一下.如果有哪位高手能改出更好的程序, 请别忘了和我说一声呀. :P 源程序的演示页面在elong.oso.com.cn/des ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrKwJp.html" rel="bookmark" class="title">如何在Word 2013自定义词典中添加和删除单词</a>
					<div>
						在Word2013中,用户可以在其提供的自定义词典中添加或删除单词,使词典更加符合自己的工作需要.在Word2013自定义词典中添加和删除单词的步骤如下所述: 第1步,打开Word2013文档窗口,依 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2yWqZz.html" rel="bookmark" class="title">解决JPGraph的中文乱码问题</a>
					<div>
						JPGraph处理有中文字符时都会转成utf8编码后显示,我们只需注释掉相关的代码就可以了. Dotproject苷特图中文乱码解决具体步骤如下: 1.修改jpgraph库 打开dotproject  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZO7Bab.html" rel="bookmark" class="title">UVa 112：Tree Summing 二叉树构造， 二叉树路径和</a>
					<div>
						题目链接: http://uva.onlinejudge.org/index.php?option=com_onlinejudge&amp;Itemid=8&amp;page=show_problem ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7Zo5M.html" rel="bookmark" class="title">JVM&lpar;Java虚拟机&rpar;详解</a>
					<div>
						可能有很多学习Java的朋友还不知道Java的运行原理.Java虚拟机是怎么工作的,本文将为你详细讲解(JVM)Java虚拟机. 在Java中引入了虚拟机的概念,即在机器和编译程序之间加入了一层抽象的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0P7XPM.html" rel="bookmark" class="title">Oracle数据库的启动与关闭方法</a>
					<div>
						这篇文章主要介绍了Oracle数据库的启动与关闭方法,需要的朋友可以参考下   一.启动数据 $sqlplus &quot;sys/pass as sysdba&quot; sql&gt;startu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNEoL4b.html" rel="bookmark" class="title">Win7多条件搜索 找回想要的文件</a>
					<div>
						想找一个文件时,大家都会想到用Win7系统中的搜索功能,但又常常会想不起文件的具体名称,甚至连什么格式都忘了,只依稀记得一些零散的内容.在这种情况下,如果一个条件一个条件,分多次进行搜索和筛选,无疑会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKOPOp.html" rel="bookmark" class="title">php实现encode64编码类实例</a>
					<div>
						 这篇文章主要介绍了php实现encode64编码类,实例分析了php实现encode64编码的技巧,具有一定参考借鉴价值,需要的朋友可以参考下     本文实例讲述了php实现encode64编码类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6go3b.html" rel="bookmark" class="title">zookeeper（一） --- zookeeper概述</a>
					<div>
						zookeeper(一) --- zookeeper概述            写文章之前笔者先说明一下笔者最近了解zookeeper的原因,最近笔者所在的项目中需要用全文索引,而架构师和项目经理决定 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXv0mp.html" rel="bookmark" class="title">Qt项目管理</a>
					<div>
						采用一个非常简单的Qt程序作为例子,通过pro文件的合理编写,使得我们的程序在使用动态库的时候,几乎可以忽略掉动态库的存在.它包括3部分: 生成动态库 使用动态库 生成与使用的自动化 测试环境: ub ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7NVVb.html" rel="bookmark" class="title">Android 设置背景透明度</a>
					<div>
						  一些时候,我们需要为UI页面设置背景色,如下图所示:   上图已注: 背景颜色为#000000,透明度为40%: 那么,如何在代码中表示呢?   首先需要了解: 颜色和不透明度 (alpha) 值 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqkKvz.html" rel="bookmark" class="title">SQL Server连接中三个常见的错误分析&lpar;转&rpar;</a>
					<div>
						一.&quot;SQL Server 不存在或访问被拒绝&quot; 这个是最复杂的,错误发生的原因比较多,需要检查的方面也比较多. 一般说来,有以下几种可能性: 1.SQL Server名称或IP地 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBgZnM.html" rel="bookmark" class="title">雷军：小米今年最重要的战略是开心就好</a>
					<div>
						去年小米手机出货量超7000万台,连续七个季度稳居国内第一 雷军:小米今年最重要的 战略是开心就好 小米从2010年初创至今,已经迎来第六个年头.经过五年的发展,小米已不只是一家手机厂商.小米手环.i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xQYKb.html" rel="bookmark" class="title">visual studio-关于vs2015gets函数调用问题</a>
					<div>
						问题描述 关于vs2015gets函数调用问题 gets函数调用用到那个头文件a,我调用stdio.h和cstdio都不可以 求大神帮助 解决方案 在VS1025中,考虑安全性,取消了gets函数,改 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXYZlb.html" rel="bookmark" class="title">微软在中国的成就</a>
					<div>
						外部环境的持续改善以及陈永正.张亚勤的适时而动.互为促进,促成了今天微软在中国的成就. &quot;中国公司拿到了微软全球最佳公司的大奖,这是我们有史以来的第一次!&quot;在9月27日微软中国媒体 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdm6q6z.html" rel="bookmark" class="title">KODA受害人&OpenCurlyDoubleQuote;抱团&rdquo;反击香港银行指控出&OpenCurlyDoubleQuote;六宗罪&rdquo;</a>
					<div>
						投资者:香港银行有&quot;六宗罪&quot; &quot;这次开会才知道,原来给我们开户理财的都是'副总裁'&quot;,7月12日,金亮(化名)在KODA受害者首次聚会结束后告诉中国证券报记者, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6GegOp.html" rel="bookmark" class="title">用户数据流量连年翻倍 移动互联网发展迅猛</a>
					<div>
						近年来,移动互联网的发展势头异常迅猛,随着智能手机的主流化,越来越多的用户将大部分的时间用在通话以外的应用,移动互联网发展形势前景开阔. 中国联通副总经理李刚:2011年智能手机用户每月数据流量是20 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEYrr6b.html" rel="bookmark" class="title">js 提取class相同的节点集合&lowbar;javascript技巧</a>
					<div>
						[Ctrl+A 全选 注:如需引入外部Js需刷新才能执行]					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmyyVp.html" rel="bookmark" class="title">两个DataGridView纵向同步滚动的问题</a>
					<div>
						问题描述 我要将两个DataGridView的滚动条在纵向同步,就是只操作一个DataGridView滚动条,另一个DataGridView也滚动到相应位置.之前查了相应问题,发现横向同步滚动可以简单 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1N4G5p.html" rel="bookmark" class="title">服务器-spring mongodb中elemMatch问题</a>
					<div>
						问题描述 spring mongodb中elemMatch问题 写服务器数据库时候有个问题. 要解决的问题是:查询某个用户所在的所有组 例如:群组的数据类型如下: [ {&quot;_id&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bByomoz.html" rel="bookmark" class="title">高盛为什么强调自己是一家技术公司？</a>
					<div>
						近两年在许多公开场合,人们都会听到高盛CEO Lloyd Blankfein反复强调,这家华尔街顶级投行的定位已不同于昔日:&quot;我们是一家技术公司.&quot; 这话听上去挺像是一句演说辞,套 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPWgWrM.html" rel="bookmark" class="title">Android自定义View示例&lpar;一&rpar;&mdash;带有删除按钮的EditText</a>
					<div>
						MainActivity如下: package cc.textview5; import android.os.Bundle; import android.text.TextUtils; impor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zenNrAb.html" rel="bookmark" class="title">关于form 的target跳转问题</a>
					<div>
						问题描述 先请问一下大家,这是我的main.html: &lt;html&gt; &lt;frameset cols=&quot;20%,*&quot;&gt;   &lt;frame src=&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVXXxDM.html" rel="bookmark" class="title">EPIC要求Google安全条款需透明化</a>
					<div>
						在EPIC撰写的15也诉状中表示,Google对于云计算服务中的客户信息没有提供足够的保护,这些云计算服务包括Gmail.Google Docs.Google Desktop.Picasa网络相册以及 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqOV5Zz.html" rel="bookmark" class="title">微软正式向开发者推送更新的开发者预览版</a>
					<div>
						摘要: 微软操作系统部门副总裁 Joe Belfiore 7 月 30 日在中国发布了 Windows Phone 8.1 的第一个 GDR 更新 Windows Phone 8.1 Update 以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK3x6Eb.html" rel="bookmark" class="title">苏宁增持PPTV股份达64&percnt;&comma;一年投资总额达数亿</a>
					<div>
						苏宁增持PPTV股份达64%12月11日消息,苏宁昨日晚间发布公告称:将增持PPTV的股份至64%.此外,苏宁方面还宣布将大力发展移动.家庭和PC视频终端.苏宁方面表示,过去一年来,苏宁不断加大对PP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBG5DJM.html" rel="bookmark" class="title">qemu参数解析</a>
					<div>
						代码版本:qemu1.5 一.qemu有哪些参数 1.qemu-options.hx文件 qemu可用参数位于qemu-options.hx文件中,例如: DEF(&quot;kernel&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvqyAab.html" rel="bookmark" class="title">审计署：北京奥运收支结余将超10亿元</a>
					<div>
						中新网6月19日电 6月19日,审计署发布今年第8号审计结果公告,公布了北京奥运会财务收支和奥运场馆建设项目跟踪审计结果.公告显示,北京奥组委收支结余将超过10亿元,审计未发现重大违法违规问题.工程建 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
